unit Edit;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, Grids, Dialogs;

type
  TEditDlg = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Bevel1: TBevel;
    DaonsTable: TStringGrid;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    EditX: TEdit;
    Label6: TLabel;
    EditY: TEdit;
    Label7: TLabel;
    EditZ: TEdit;
    Label9: TLabel;
    Label8: TLabel;
    EditV: TEdit;
    Label10: TLabel;
    EditU: TEdit;
    Label11: TLabel;
    EditW: TEdit;
    Submit: TBitBtn;
    Label12: TLabel;
    NumberOfTaon: TLabel;
    Label15: TLabel;
    EditDT: TEdit;
    EditA1: TEdit;
    EditB1: TEdit;
    EditC1: TEdit;
    EditD1: TEdit;
    EditF1: TEdit;
    EditA2: TEdit;
    EditB2: TEdit;
    EditC2: TEdit;
    EditD2: TEdit;
    EditF2: TEdit;
    EditA3: TEdit;
    EditB3: TEdit;
    EditC3: TEdit;
    EditD3: TEdit;
    EditF3: TEdit;
    Label16: TLabel;
    DaoTrue: TCheckBox;
    Label13: TLabel;
    SaveDialog: TSaveDialog;
    Saveas: TButton;
    EditFileName: TEdit;
    Label24: TLabel;
    Label25: TLabel;
    Label14: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label21: TLabel;
    Label20: TLabel;
    Label22: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label17: TLabel;
    Label23: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label37: TLabel;
    EditCal1Part1: TEdit;
    EditCal1Part2: TEdit;
    EditCal2Part1: TEdit;
    EditCal2Part2: TEdit;
    EditCal3Part1: TEdit;
    EditCal3Part2: TEdit;
    EditCal4Part1: TEdit;
    EditCal4Part2: TEdit;
    EditResult1: TEdit;
    EditResult2: TEdit;
    EditResult3: TEdit;
    EditResult4: TEdit;    
    Calculate1: TButton;
    Reset1: TButton;
    Calculate2: TButton;
    Reset2: TButton;
    Calculate3: TButton;
    Reset3: TButton;
    Label29: TLabel;
    Label33: TLabel;
    Label36: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    Label42: TLabel;
    Edit8: TEdit;
    Calculate4: TButton;
    Reset4: TButton;
    EditG1: TEdit;
    EditG2: TEdit;
    EditG3: TEdit;
    Label43: TLabel;
    Label44: TLabel;
    Label45: TLabel;
    procedure DaonsTableDblClick(Sender: TObject);
    procedure EditDTKeyPress(Sender: TObject; var Key: Char);
    procedure EditA1KeyPress(Sender: TObject; var Key: Char);
    procedure EditB1KeyPress(Sender: TObject; var Key: Char);
    procedure EditC1KeyPress(Sender: TObject; var Key: Char);
    procedure EditD1KeyPress(Sender: TObject; var Key: Char);
    procedure EditF1KeyPress(Sender: TObject; var Key: Char);
    procedure EditG1KeyPress(Sender: TObject; var Key: Char);
    procedure EditA2KeyPress(Sender: TObject; var Key: Char);
    procedure EditB2KeyPress(Sender: TObject; var Key: Char);
    procedure EditC2KeyPress(Sender: TObject; var Key: Char);
    procedure EditD2KeyPress(Sender: TObject; var Key: Char);
    procedure EditF2KeyPress(Sender: TObject; var Key: Char);
    procedure EditG2KeyPress(Sender: TObject; var Key: Char);
    procedure EditA3KeyPress(Sender: TObject; var Key: Char);
    procedure EditB3KeyPress(Sender: TObject; var Key: Char);
    procedure EditC3KeyPress(Sender: TObject; var Key: Char);
    procedure EditD3KeyPress(Sender: TObject; var Key: Char);
    procedure EditF3KeyPress(Sender: TObject; var Key: Char);
    procedure EditG3KeyPress(Sender: TObject; var Key: Char);
    procedure EditUKeyPress(Sender: TObject; var Key: Char);
    procedure EditVKeyPress(Sender: TObject; var Key: Char);
    procedure EditWKeyPress(Sender: TObject; var Key: Char);
    procedure EditXKeyPress(Sender: TObject; var Key: Char);
    procedure EditYKeyPress(Sender: TObject; var Key: Char);
    procedure EditZKeyPress(Sender: TObject; var Key: Char);

    procedure EditCal1Part1KeyPress(Sender: TObject; var Key: Char);
    procedure EditCal1Part2KeyPress(Sender: TObject; var Key: Char);
    procedure EditCal2Part1KeyPress(Sender: TObject; var Key: Char);
    procedure EditCal2Part2KeyPress(Sender: TObject; var Key: Char);
    procedure EditCal3Part1KeyPress(Sender: TObject; var Key: Char);
    procedure EditCal3Part2KeyPress(Sender: TObject; var Key: Char);
    procedure EditCal4Part1KeyPress(Sender: TObject; var Key: Char);
    procedure EditCal4Part2KeyPress(Sender: TObject; var Key: Char);

    procedure DaonsTableSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure FormPaint(Sender: TObject);
    procedure SubmitClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);

    procedure Calculate1Click(Sender: TObject);
    procedure Reset1Click(Sender: TObject);
    procedure Calculate2Click(Sender: TObject);
    procedure Reset2Click(Sender: TObject);
    procedure Calculate3Click(Sender: TObject);
    procedure Reset3Click(Sender: TObject);
    procedure Calculate4Click(Sender: TObject);
    procedure Reset4Click(Sender: TObject);

    procedure SaveasClick(Sender: TObject);
    procedure DaonsTableClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  EditDlg: TEditDlg;

implementation

uses Global, Main;

{$R *.DFM}

var
   VeloCity
                    :boolean;

procedure ShowTable1;
var ii,jj:integer;
begin
with EditDlg do
     with DaonsTable do
     if not VeloCity
     then
     begin
     Cells[0,0]:='Gravons';
     Cells[1,0]:='X';Cells[2,0]:='Y';Cells[3,0]:='Z';
     for jj:=1 to MaxTaons do
         Cells[0,jj]:=IntToStr(jj);

     for ii := 1 to MaxTaons do
     for jj:= 1 to RowCount do
     if Dao[ii]
        then
        case jj of

         1:Cells[jj,ii] := FloatToStr(Xo[ii]);
         2:Cells[jj,ii] := FloatToStr(Yo[ii]);
         3:Cells[jj,ii] := FloatToStr(Zo[ii]);
        end
        else
            Cells[jj,ii] := '';
     end
     else
     begin
     Cells[0,0]:='Velo';
     Cells[1,0]:='u(x)';Cells[2,0]:='u(y)';Cells[3,0]:='u(z)';
     for jj:=1 to MaxTaons do
         Cells[0,jj]:=IntToStr(jj);

     for ii := 1 to MaxTaons do
     for jj:= 1 to RowCount do
     if Dao[ii]
        then
        case jj of
         1:Cells[jj,ii] := FloatToStr(Vo[ii]);
         2:Cells[jj,ii] := FloatToStr(Uo[ii]);
         3:Cells[jj,ii] := FloatToStr(Wo[ii]);
        end
        else
            Cells[jj,ii] := '';
     end;
end;
// End special procedures

procedure TEditDlg.DaonsTableDblClick(Sender: TObject);
begin
VeloCity:=not VeloCity; ShowTable1;
end;

procedure TEditDlg.EditDTKeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditCal1Part1KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditCal1Part2KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditCal2Part1KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditCal2Part2KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditCal3Part1KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditCal3Part2KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditCal4Part1KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditCal4Part2KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditA1KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditB1KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditC1KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditD1KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditF1KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditG1KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditA2KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditB2KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditC2KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditD2KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditF2KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditG2KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditA3KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditB3KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditC3KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditD3KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditF3KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditG3KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditUKeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditVKeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditWKeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditXKeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditYKeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TEditDlg.EditZKeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

//CALCULATION 1
procedure TEditDlg.Calculate1Click(Sender: TObject);
var  n1, n2   :integer;
X1, X2, Y1, Y2, Z1, Z2, D  :extended;

begin

   n1:=StrToInt(EditCal1Part1.Text);
   X1:=StrToFloat(DaonsTable.Cells[1,n1]);
   Y1:=StrToFloat(DaonsTable.Cells[2,n1]);
   Z1:=StrToFloat(DaonsTable.Cells[3,n1]);

   n2:=StrToInt(EditCal1Part2.Text);
   X2:=StrToFloat(DaonsTable.Cells[1,n2]);
   Y2:=StrToFloat(DaonsTable.Cells[2,n2]);
   Z2:=StrToFloat(DaonsTable.Cells[3,n2]);

   D:=Sqrt((Sqr(X2-X1))+(Sqr(Y2-Y1))+(Sqr(Z2-Z1)));
   EditResult1.Text:='0';
   EditResult1.Text:=FloatToStr(D);
end;

procedure TEditDlg.Reset1Click(Sender: TObject);
begin
EditCal1Part1.Text:='0'; EditCal1Part2.Text:='0'; EditResult1.Text:='0';
end;
//CALCULATION 2
procedure TEditDlg.Calculate2Click(Sender: TObject);
var  n1, n2   :integer;
X1, X2, Y1, Y2, Z1, Z2, D  :extended;

begin

   n1:=StrToInt(EditCal2Part1.Text);
   X1:=StrToFloat(DaonsTable.Cells[1,n1]);
   Y1:=StrToFloat(DaonsTable.Cells[2,n1]);
   Z1:=StrToFloat(DaonsTable.Cells[3,n1]);

   n2:=StrToInt(EditCal2Part2.Text);
   X2:=StrToFloat(DaonsTable.Cells[1,n2]);
   Y2:=StrToFloat(DaonsTable.Cells[2,n2]);
   Z2:=StrToFloat(DaonsTable.Cells[3,n2]);

   D:=Sqrt((Sqr(X2-X1))+(Sqr(Y2-Y1))+(Sqr(Z2-Z1)));
   EditResult2.Text:='0';
   EditResult2.Text:=FloatToStr(D);
end;

procedure TEditDlg.Reset2Click(Sender: TObject);
begin
EditCal2Part1.Text:='0'; EditCal2Part2.Text:='0'; EditResult2.Text:='0';
end;
//CALCULATION 3
procedure TEditDlg.Calculate3Click(Sender: TObject);
var  n1, n2   :integer;
X1, X2, Y1, Y2, Z1, Z2, D  :extended;

begin

   n1:=StrToInt(EditCal3Part1.Text);
   X1:=StrToFloat(DaonsTable.Cells[1,n1]);
   Y1:=StrToFloat(DaonsTable.Cells[2,n1]);
   Z1:=StrToFloat(DaonsTable.Cells[3,n1]);

   n2:=StrToInt(EditCal3Part2.Text);
   X2:=StrToFloat(DaonsTable.Cells[1,n2]);
   Y2:=StrToFloat(DaonsTable.Cells[2,n2]);
   Z2:=StrToFloat(DaonsTable.Cells[3,n2]);

   D:=Sqrt((Sqr(X2-X1))+(Sqr(Y2-Y1))+(Sqr(Z2-Z1)));
   EditResult3.Text:='0';
   EditResult3.Text:=FloatToStr(D);
end;

procedure TEditDlg.Reset3Click(Sender: TObject);
begin
EditCal3Part1.Text:='0'; EditCal3Part2.Text:='0'; EditResult3.Text:='0';
end;
//CALCULATION 4
procedure TEditDlg.Calculate4Click(Sender: TObject);
var  n1, n2   :integer;
X1, X2, Y1, Y2, Z1, Z2, D  :extended;

begin

   n1:=StrToInt(EditCal4Part1.Text);
   X1:=StrToFloat(DaonsTable.Cells[1,n1]);
   Y1:=StrToFloat(DaonsTable.Cells[2,n1]);
   Z1:=StrToFloat(DaonsTable.Cells[3,n1]);

   n2:=StrToInt(EditCal4Part2.Text);
   X2:=StrToFloat(DaonsTable.Cells[1,n2]);
   Y2:=StrToFloat(DaonsTable.Cells[2,n2]);
   Z2:=StrToFloat(DaonsTable.Cells[3,n2]);

   D:=Sqrt((Sqr(X2-X1))+(Sqr(Y2-Y1))+(Sqr(Z2-Z1)));
   EditResult4.Text:='0';
   EditResult4.Text:=FloatToStr(D);
end;

procedure TEditDlg.Reset4Click(Sender: TObject);
begin
EditCal4Part1.Text:='0'; EditCal4Part2.Text:='0'; EditResult4.Text:='0';
end;

procedure TEditDlg.DaonsTableSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
NumberOfTaon.Caption:=IntToStr(DaonsTable.Row);
EditX.Text:=FloatToStr(Xo[DaonsTable.Row]);
EditY.Text:=FloatToStr(Yo[DaonsTable.Row]);
EditZ.Text:=FloatToStr(Zo[DaonsTable.Row]);
EditV.Text:=FloatToStr(Vo[DaonsTable.Row]);
EditU.Text:=FloatToStr(Uo[DaonsTable.Row]);
EditW.Text:=FloatToStr(Wo[DaonsTable.Row]);
if Dao[DaonsTable.Row]
   then DaoTrue.Checked:=true
   else DaoTrue.Checked:=false;
end;

procedure TEditDlg.FormPaint(Sender: TObject);
begin
EditFileName.Text:=ThisName;
NumberOfTaon.Caption:=IntToStr(DaonsTable.Row);
EditX.Text:=FloatToStr(Xo[DaonsTable.Row]);
EditY.Text:=FloatToStr(Yo[DaonsTable.Row]);
EditZ.Text:=FloatToStr(Zo[DaonsTable.Row]);
EditV.Text:=FloatToStr(Vo[DaonsTable.Row]);
EditU.Text:=FloatToStr(Uo[DaonsTable.Row]);
EditW.Text:=FloatToStr(Wo[DaonsTable.Row]);
if Dao[DaonsTable.Row]
   then DaoTrue.Checked:=true
   else DaoTrue.Checked:=false;
   EditDT.Text:=FloatToStr(dt);
   EditA1.Text:=FloatToStr(A1);
   EditB1.Text:=FloatToStr(B1);
   EditC1.Text:=FloatToStr(C1);
   EditD1.Text:=FloatToStr(D1);
   EditF1.Text:=FloatToStr(F1);
   EditG1.Text:=FloatToStr(G1);
   EditA2.Text:=FloatToStr(A2);
   EditB2.Text:=FloatToStr(B2);
   EditC2.Text:=FloatToStr(C2);
   EditD2.Text:=FloatToStr(D2);
   EditF2.Text:=FloatToStr(F2);
   EditG2.Text:=FloatToStr(G2);
   EditA3.Text:=FloatToStr(A3);
   EditB3.Text:=FloatToStr(B3);
   EditC3.Text:=FloatToStr(C3);
   EditD3.Text:=FloatToStr(D3);
   EditF3.Text:=FloatToStr(F3);
   EditG3.Text:=FloatToStr(G3);

ShowTable1;
end;

  //  ************
procedure TEditDlg.SubmitClick(Sender: TObject);
var n:integer;
begin
n:=StrToInt(NumberOfTaon.Caption);
Xo[n]:=StrToFloat(EditX.Text);
Yo[n]:=StrToFloat(EditY.Text);
Zo[n]:=StrToFloat(EditZ.Text);
Vo[n]:=StrToFloat(EditV.Text);
Uo[n]:=StrToFloat(EditU.Text);
Wo[n]:=StrToFloat(EditW.Text);
if DaoTrue.Checked
   then Dao[n]:=true
   else Dao[n]:=false;
ShowTable1;
end;

procedure TEditDlg.OKBtnClick(Sender: TObject);
var n:integer;
begin
if SaveDialog.Execute then
begin
// SaveFile
dt:=StrToFloat(EditDT.Text);
A1:=StrToFloat(EditA1.Text);
B1:=StrToFloat(EditB1.Text);
C1:=StrToFloat(EditC1.Text);
D1:=StrToFloat(EditD1.Text);
F1:=StrToFloat(EditF1.Text);
G1:=StrToFloat(EditG1.Text);
A2:=StrToFloat(EditA2.Text);
B2:=StrToFloat(EditB2.Text);
C2:=StrToFloat(EditC2.Text);
D2:=StrToFloat(EditD2.Text);
F2:=StrToFloat(EditF2.Text);
G2:=StrToFloat(EditG2.Text);
A3:=StrToFloat(EditA3.Text);
B3:=StrToFloat(EditB3.Text);
C3:=StrToFloat(EditC3.Text);
D3:=StrToFloat(EditD3.Text);
F3:=StrToFloat(EditF3.Text);
G3:=StrToFloat(EditG3.Text);
SaveDataOfTaons;
AssignFile(FTaons,SaveDialog.FileName);
Rewrite(FTaons);
Write(FTaons, Taons);
CloseFile(FTaons);
// end SaveFile
ThisName:=SaveDialog.FileName;
StartFile:=ThisName;
{$I-}
Rewrite(FStartFile);
{$I+}
Write(FStartFile,StartFile);
CloseFile(FStartFile);

dt:=StrToFloat(EditDT.Text);
A1:=StrToFloat(EditA1.Text);
B1:=StrToFloat(EditB1.Text);
C1:=StrToFloat(EditC1.Text);
D1:=StrToFloat(EditD1.Text);
F1:=StrToFloat(EditF1.Text);
G1:=StrToFloat(EditG1.Text);
A2:=StrToFloat(EditA2.Text);
B2:=StrToFloat(EditB2.Text);
C2:=StrToFloat(EditC2.Text);
D2:=StrToFloat(EditD2.Text);
F2:=StrToFloat(EditF2.Text);
G2:=StrToFloat(EditG2.Text);
A3:=StrToFloat(EditA3.Text);
B3:=StrToFloat(EditB3.Text);
C3:=StrToFloat(EditC3.Text);
D3:=StrToFloat(EditD3.Text);
F3:=StrToFloat(EditF3.Text);
G3:=StrToFloat(EditG3.Text);
for n:=1 to MaxTaons do
    if Dao[n] then
       begin
            x[n]:=Xo[n];Xn[n]:=Xo[n];
            y[n]:=Yo[n];Yn[n]:=Yo[n];
            z[n]:=Zo[n];Zn[n]:=Zo[n];
            Vn[n]:=Vo[n];
            Un[n]:=Uo[n];
            Wn[n]:=Wo[n];
       end;
end;//SaveDialog
end;

procedure TEditDlg.SaveasClick(Sender: TObject);
begin
if SaveDialog.Execute then
   begin
   EditFileName.Text:=SaveDialog.FileName;
   dt:=StrToFloat(EditDT.Text);
   A1:=StrToFloat(EditA1.Text);
   B1:=StrToFloat(EditB1.Text);
   C1:=StrToFloat(EditC1.Text);
   D1:=StrToFloat(EditD1.Text);
   F1:=StrToFloat(EditF1.Text);
   G1:=StrToFloat(EditG1.Text);
   A2:=StrToFloat(EditA2.Text);
   B2:=StrToFloat(EditB2.Text);
   C2:=StrToFloat(EditC2.Text);
   D2:=StrToFloat(EditD2.Text);
   F2:=StrToFloat(EditF2.Text);
   G2:=StrToFloat(EditG2.Text);
   A3:=StrToFloat(EditA3.Text);
   B3:=StrToFloat(EditB3.Text);
   C3:=StrToFloat(EditC3.Text);
   D3:=StrToFloat(EditD3.Text);
   F3:=StrToFloat(EditF3.Text);
   G3:=StrToFloat(EditG3.Text);
   SaveDataOfTaons;
   AssignFile(FTaons,SaveDialog.FileName);
   Rewrite(FTaons);
   Write(FTaons, Taons);
   CloseFile(FTaons);
   end;
end;

procedure TEditDlg.DaonsTableClick(Sender: TObject);
begin
NumberOfTaon.Caption:=IntToStr(DaonsTable.Row);
EditX.Text:=FloatToStr(Xo[DaonsTable.Row]);
EditY.Text:=FloatToStr(Yo[DaonsTable.Row]);
EditZ.Text:=FloatToStr(Zo[DaonsTable.Row]);
EditV.Text:=FloatToStr(Vo[DaonsTable.Row]);
EditU.Text:=FloatToStr(Uo[DaonsTable.Row]);
EditW.Text:=FloatToStr(Wo[DaonsTable.Row]);
if Dao[DaonsTable.Row]
   then DaoTrue.Checked:=true
   else DaoTrue.Checked:=false;
ShowTable1;

end;

end.
