unit Figures;

{$N+}

interface

procedure CreateFigure;

implementation

uses Global;

procedure CreateFigure;
var

   tx,ty,tz,           //   

   x1,y1,z1,
   x2,y2,z2,           //  

   HTri,               //  
   Mi,                 //     
   H,                  //  
   //H2,                 //  
   Luch                //    .
                       : extended;
   i                   // counter
                       : integer;

   procedure Middle(L:real);
   begin
   tx:=(x1+L*x2)/(1+L);
   ty:=(y1+L*y2)/(1+L);
   tz:=(z1+L*z2)/(1+L);
   end;//Middle
begin // Create
for i:=1 to MaxPunkt do
    begin x[i]:=0;y[i]:=0;z[i]:=0 end;
if Spiral
then
case TypeSpiral of
0:;
1:
    begin
       Luch:=0.5/sin(Pi/3);
       HTri:=Sqrt(1-Sqr(0.5));
       H:=Sqrt(Sqr(HTri)-Sqr(0.5));

       // First triangle
       x[1]:=0;y[1]:=0;z[1]:=0; // Start punkt
       x[2]:=1;y[2]:=0;z[2]:=0;
       x[3]:=0.5;y[3]:=0;z[3]:=HTri;
       //tx:=0.5;ty:=0;tz:=Htri-Luch;

       // First tetra
       x[4]:=0.5;y[4]:=H;z[4]:=HTri-Luch;

       // 2-Tetra
       x[5]:=0.5;y[5]:=-H;z[5]:=HTri-Luch;

       // 3-Tetra
       //    1 - 2
       x1:=x[1];y1:=y[1];z1:=z[1];
       x2:=x[2];y2:=y[2];z2:=z[2];
       Mi:=1;
       Middle(Mi);
       x1:=tx;y1:=ty;z1:=tz;
       x2:=x[5];y2:=y[5];z2:=z[5];
       Mi:=(HTri-Luch)/Luch;
       Middle(Mi);
       //   
       //     
       x1:=x[3];y1:=y[3];z1:=z[3];
       x2:=2*tx-x1;
       y2:=2*ty-y1;
       z2:=2*tz-z1;
       x[6]:=x2;y[6]:=y2;z[6]:=z2;

       // 4-Tetra
       //    1 - 2
       x1:=x[1];y1:=y[1];z1:=z[1];
       x2:=x[2];y2:=y[2];z2:=z[2];
       Mi:=1;
       Middle(Mi);
       x1:=tx;y1:=ty;z1:=tz;
       x2:=x[6];y2:=y[6];z2:=z[6];
       Mi:=(HTri-Luch)/Luch;
       Middle(Mi);
       //   
       //     
       x1:=x[5];y1:=y[5];z1:=z[5];
       x2:=2*tx-x1;
       y2:=2*ty-y1;
       z2:=2*tz-z1;
       x[7]:=x2;y[7]:=y2;z[7]:=z2;

       // 5-Tetra
       x1:=x[2];y1:=y[2];z1:=z[2];
       x2:=x[6];y2:=y[6];z2:=z[6];
       Mi:=1;
       Middle(Mi);
       x1:=tx;y1:=ty;z1:=tz;
       x2:=x[7];y2:=y[7];z2:=z[7];
       Mi:=(HTri-Luch)/Luch;
       Middle(Mi);
       //   
       //     
       x1:=x[1];y1:=y[1];z1:=z[1];
       x2:=2*tx-x1;
       y2:=2*ty-y1;
       z2:=2*tz-z1;
       x[8]:=x2;y[8]:=y2;z[8]:=z2;

       // 6-Tetra
       x1:=x[2];y1:=y[2];z1:=z[2];
       x2:=x[6];y2:=y[6];z2:=z[6];
       Mi:=1;
       Middle(Mi);
       x1:=tx;y1:=ty;z1:=tz;
       x2:=x[8];y2:=y[8];z2:=z[8];
       Mi:=(HTri-Luch)/Luch;
       Middle(Mi);
       x1:=x[7];y1:=y[7];z1:=z[7];
       x2:=2*tx-x1;
       y2:=2*ty-y1;
       z2:=2*tz-z1;
       x[9]:=x2;y[9]:=y2;z[9]:=z2;

       // 7-Tetra
       x1:=x[2];y1:=y[2];z1:=z[2];
       x2:=x[8];y2:=y[8];z2:=z[8];
       Mi:=1;
       Middle(Mi);
       x1:=tx;y1:=ty;z1:=tz;
       x2:=x[9];y2:=y[9];z2:=z[9];
       Mi:=(HTri-Luch)/Luch;
       Middle(Mi);
       x1:=x[6];y1:=y[6];z1:=z[6];
       x2:=2*tx-x1;
       y2:=2*ty-y1;
       z2:=2*tz-z1;
       x[10]:=x2;y[10]:=y2;z[10]:=z2;

       // 8-Tetra
       x1:=x[2];y1:=y[2];z1:=z[2];
       x2:=x[8];y2:=y[8];z2:=z[8];
       Mi:=1;
       Middle(Mi);
       x1:=tx;y1:=ty;z1:=tz;
       x2:=x[10];y2:=y[10];z2:=z[10];
       Mi:=(HTri-Luch)/Luch;
       Middle(Mi);
       x1:=x[9];y1:=y[9];z1:=z[9];
       x2:=2*tx-x1;
       y2:=2*ty-y1;
       z2:=2*tz-z1;
       x[11]:=x2;y[11]:=y2;z[11]:=z2;

       // 9-Tetra
       x1:=x[2];y1:=y[2];z1:=z[2];
       x2:=x[10];y2:=y[10];z2:=z[10];
       Mi:=1;
       Middle(Mi);
       x1:=tx;y1:=ty;z1:=tz;
       x2:=x[11];y2:=y[11];z2:=z[11];
       Mi:=(HTri-Luch)/Luch;
       Middle(Mi);
       x1:=x[8];y1:=y[8];z1:=z[8];
       x2:=2*tx-x1;
       y2:=2*ty-y1;
       z2:=2*tz-z1;
       x[12]:=x2;y[12]:=y2;z[12]:=z2;

       // 10-Tetra
       x1:=x[2];y1:=y[2];z1:=z[2];
       x2:=x[10];y2:=y[10];z2:=z[10];
       Mi:=1;
       Middle(Mi);
       x1:=tx;y1:=ty;z1:=tz;
       x2:=x[12];y2:=y[12];z2:=z[12];
       Mi:=(HTri-Luch)/Luch;
       Middle(Mi);
       x1:=x[11];y1:=y[11];z1:=z[11];
       x2:=2*tx-x1;
       y2:=2*ty-y1;
       z2:=2*tz-z1;
       x[13]:=x2;y[13]:=y2;z[13]:=z2;

       // 11-Tetra
       x1:=x[10];y1:=y[10];z1:=z[10];
       x2:=x[12];y2:=y[12];z2:=z[12];
       Mi:=1;
       Middle(Mi);
       x1:=tx;y1:=ty;z1:=tz;
       x2:=x[13];y2:=y[13];z2:=z[13];
       Mi:=(HTri-Luch)/Luch;
       Middle(Mi);
       x1:=x[2];y1:=y[2];z1:=z[2];
       x2:=2*tx-x1;
       y2:=2*ty-y1;
       z2:=2*tz-z1;
       x[14]:=x2;y[14]:=y2;z[14]:=z2;

       // 12-Tetra
       x1:=x[10];y1:=y[10];z1:=z[10];
       x2:=x[12];y2:=y[12];z2:=z[12];
       Mi:=1;
       Middle(Mi);
       x1:=tx;y1:=ty;z1:=tz;
       x2:=x[14];y2:=y[14];z2:=z[14];
       Mi:=(HTri-Luch)/Luch;
       Middle(Mi);
       x1:=x[13];y1:=y[13];z1:=z[13];
       x2:=2*tx-x1;
       y2:=2*ty-y1;
       z2:=2*tz-z1;
       x[15]:=x2;y[15]:=y2;z[15]:=z2;

       // 13-Tetra
       x1:=x[10];y1:=y[10];z1:=z[10];
       x2:=x[14];y2:=y[14];z2:=z[14];
       Mi:=1;
       Middle(Mi);
       x1:=tx;y1:=ty;z1:=tz;
       x2:=x[15];y2:=y[15];z2:=z[15];
       Mi:=(HTri-Luch)/Luch;
       Middle(Mi);
       x1:=x[12];y1:=y[12];z1:=z[12];
       x2:=2*tx-x1;
       y2:=2*ty-y1;
       z2:=2*tz-z1;
       x[16]:=x2;y[16]:=y2;z[16]:=z2;

       // 14-Tetra
       x1:=x[10];y1:=y[10];z1:=z[10];
       x2:=x[14];y2:=y[14];z2:=z[14];
       Mi:=1;
       Middle(Mi);
       x1:=tx;y1:=ty;z1:=tz;
       x2:=x[16];y2:=y[16];z2:=z[16];
       Mi:=(HTri-Luch)/Luch;
       Middle(Mi);
       x1:=x[15];y1:=y[15];z1:=z[15];
       x2:=2*tx-x1;
       y2:=2*ty-y1;
       z2:=2*tz-z1;
       x[17]:=x2;y[17]:=y2;z[17]:=z2;

       // 15-Tetra
       x1:=x[10];y1:=y[10];z1:=z[10];
       x2:=x[16];y2:=y[16];z2:=z[16];
       Mi:=1;
       Middle(Mi);
       x1:=tx;y1:=ty;z1:=tz;
       x2:=x[17];y2:=y[17];z2:=z[17];
       Mi:=(HTri-Luch)/Luch;
       Middle(Mi);
       x1:=x[14];y1:=y[14];z1:=z[14];
       x2:=2*tx-x1;
       y2:=2*ty-y1;
       z2:=2*tz-z1;
       x[18]:=x2;y[18]:=y2;z[18]:=z2;

       // 16-Tetra
       x1:=x[10];y1:=y[10];z1:=z[10];
       x2:=x[16];y2:=y[16];z2:=z[16];
       Mi:=1;
       Middle(Mi);
       x1:=tx;y1:=ty;z1:=tz;
       x2:=x[18];y2:=y[18];z2:=z[18];
       Mi:=(HTri-Luch)/Luch;
       Middle(Mi);
       x1:=x[17];y1:=y[17];z1:=z[17];
       x2:=2*tx-x1;
       y2:=2*ty-y1;
       z2:=2*tz-z1;
       x[19]:=x2;y[19]:=y2;z[19]:=z2;

    end;
2:;
3:;
end // case
else
    begin
        // Input hard values of square
        // =5; =1.5;   =0.424.
        // a/2 = 0.212

        x[1]:=0.212; y[1]:=0.212;z[1]:=-0.212;
        x[2]:=0.212; y[2]:=0.212;z[2]:=0.212;
        x[3]:=-0.212;y[3]:=0.212;z[3]:=0.212;
        x[4]:=-0.212;y[4]:=0.212;z[4]:=-0.212;

     A1:=1;
     B1:=2.718;
     C1:=5;
     D1:=10;
     F1:=20;
     G1:=30;
     A2:=1;
     B2:=2.718;
     C2:=5;
     D2:=10;
     F2:=20;
     G2:=30;
     A3:=1;
     B3:=2.718;
     C3:=5;
     D3:=10;
     F3:=20;
     G3:=30;


    // Input start data x,y,z.V,U,W.
    for i:=1 to 4 do
       begin
           Dao[i]:=true;
           Vo[i]:=0;Uo[i]:=0;Wo[i]:=0;
           Vn[i]:=Vo[i];Un[i]:=Uo[i];Wn[i]:=Wo[i];
           Xo[i]:=x[i];Xn[i]:=Xo[i];
           Yo[i]:=y[i];Yn[i]:=Yo[i];
           Zo[i]:=z[i];Zn[i]:=Zo[i];
       end;
    //MaxTaons:=4;
    end;
end;// CreateFigure

end.


