unit Main;
           
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, Menus, StdCtrls, Buttons, Grids;

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Saveas1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Help0: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Timer: TTimer;
    Bevel: TBevel;
    View1: TMenuItem;
    ShowSpin: TMenuItem;
    ShowNumbersOfPoints: TMenuItem;
    Images: TMenuItem;
    Daons1: TMenuItem;
    Manager1: TMenuItem;
    Left1: TMenuItem;
    Right1: TMenuItem;
    Up1: TMenuItem;
    Down1: TMenuItem;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    MoveToCenter: TMenuItem;
    RusHelp: TMenuItem;
    PolHelp: TMenuItem;
    Pan: TPanel;
    Panel1: TPanel;
    DaoTeta1: TSpeedButton;
    DaoStop: TSpeedButton;
    DaoPsi: TSpeedButton;
    DaoPsi1: TSpeedButton;
    DaoTeta: TSpeedButton;
    DaoPhi1: TSpeedButton;
    DaoPhi: TSpeedButton;
    DaoForvard: TSpeedButton;
    DaoBack: TSpeedButton;
    ShapeLime: TShape;
    ShapeRed: TShape;
    LTime: TLabel;
    Label1: TLabel;
    DtLabel: TLabel;
    Null00: TSpeedButton;
    TrackBar: TTrackBar;
    Go: TBitBtn;
    ShowList: TCheckBox;
    EditDT: TEdit;
    FName: TEdit;
    PageControl: TPageControl;
    TabSheet1: TTabSheet;
    DaonsTable: TStringGrid;
    TabSheet2: TTabSheet;
    Comment: TMemo;
    EditA1: TEdit;
    EditB1: TEdit;
    EditC1: TEdit;
    EditD1: TEdit;
    EditF1: TEdit;
    EditA2: TEdit;
    EditB2: TEdit;
    EditC2: TEdit;
    EditD2: TEdit;
    EditF2: TEdit;
    EditA3: TEdit;
    EditB3: TEdit;
    EditC3: TEdit;
    EditD3: TEdit;
    EditF3: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label6: TLabel;
   Label9: TLabel;
    Cool: TCheckBox;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    EditG1: TEdit;
    EditG2: TEdit;
    EditG3: TEdit;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    procedure Exit1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ShowSpinClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure DaoTeta1Click(Sender: TObject);
    procedure DaoTetaClick(Sender: TObject);
    procedure DaoPsiClick(Sender: TObject);
    procedure DaoPsi1Click(Sender: TObject);
    procedure DaoStopClick(Sender: TObject);
    procedure DaoPhi1Click(Sender: TObject);
    procedure DaoPhiClick(Sender: TObject);
    procedure DaoBackClick(Sender: TObject);
    procedure DaoForvardClick(Sender: TObject);
    procedure TrackBarChange(Sender: TObject);
    procedure ShowNumbersOfPointsClick(Sender: TObject);
    procedure Spiral1Click(Sender: TObject);
    procedure Daons1Click(Sender: TObject);
    procedure Left1Click(Sender: TObject);
    procedure Right1Click(Sender: TObject);
    procedure Up1Click(Sender: TObject);
    procedure Down1Click(Sender: TObject);
    procedure GoClick(Sender: TObject);
    procedure DaonsTableDblClick(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Saveas1Click(Sender: TObject);
    procedure MoveToCenterClick(Sender: TObject);
    procedure CommentChange(Sender: TObject);
    procedure CommentExit(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure RusHelpClick(Sender: TObject);
    procedure PolHelpClick(Sender: TObject);
    procedure EditDTKeyPress(Sender: TObject; var Key: Char);
    procedure EditA1KeyPress(Sender: TObject; var Key: Char);
    procedure EditB1KeyPress(Sender: TObject; var Key: Char);
    procedure EditC1KeyPress(Sender: TObject; var Key: Char);
    procedure EditD1KeyPress(Sender: TObject; var Key: Char);
    procedure EditF1KeyPress(Sender: TObject; var Key: Char);
    procedure EditG1KeyPress(Sender: TObject; var Key: Char);
    procedure EditA2KeyPress(Sender: TObject; var Key: Char);
    procedure EditB2KeyPress(Sender: TObject; var Key: Char);
    procedure EditC2KeyPress(Sender: TObject; var Key: Char);
    procedure EditD2KeyPress(Sender: TObject; var Key: Char);
    procedure EditF2KeyPress(Sender: TObject; var Key: Char);
    procedure EditG2KeyPress(Sender: TObject; var Key: Char);
    procedure EditA3KeyPress(Sender: TObject; var Key: Char);
    procedure EditB3KeyPress(Sender: TObject; var Key: Char);
    procedure EditC3KeyPress(Sender: TObject; var Key: Char);
    procedure EditD3KeyPress(Sender: TObject; var Key: Char);
    procedure EditF3KeyPress(Sender: TObject; var Key: Char);
    procedure EditG3KeyPress(Sender: TObject; var Key: Char);
    procedure EditDTExit(Sender: TObject);
    procedure EditA1Exit(Sender: TObject);
    procedure EditB1Exit(Sender: TObject);
    procedure EditC1Exit(Sender: TObject);
    procedure EditD1Exit(Sender: TObject);
    procedure EditF1Exit(Sender: TObject);
    procedure EditG1Exit(Sender: TObject);
    procedure EditA2Exit(Sender: TObject);
    procedure EditB2Exit(Sender: TObject);
    procedure EditC2Exit(Sender: TObject);
    procedure EditD2Exit(Sender: TObject);
    procedure EditF2Exit(Sender: TObject);
    procedure EditG2Exit(Sender: TObject);
    procedure EditA3Exit(Sender: TObject);
    procedure EditB3Exit(Sender: TObject);
    procedure EditC3Exit(Sender: TObject);
    procedure EditD3Exit(Sender: TObject);
    procedure EditF3Exit(Sender: TObject);
    procedure EditG3Exit(Sender: TObject);
    procedure Null00Click(Sender: TObject);
    procedure LTimeDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$N+}

uses Global, Figures, Edit, About;

{$R *.DFM}

var
   //Power,             // Type of formula
   ShowLabelTime,
   EditComm,          // Comment is changed
   ShowNumbersOfPunkts,
   VeloCity,
   Spin               // Spin
                      :boolean;
   LStartX,LStartY,
   RStartX,RStartY
                      :integer;
   KoBok,             //  
   KoRass,            // Koeff for length
   KoUgol             // Koeff
                      :extended;

procedure ClearCub;
begin
     with MainForm do
     with Canvas do
          begin
          Pen.Color:=clBlack;Brush.Color:=clBlack;
          Rectangle(Bevel.Left,Bevel.Top,Width,Pan.Top);
          end;
end;

procedure ShowTable;
var ii,jj:integer;
begin
with MainForm do
     with DaonsTable do
     if not VeloCity
     then
     begin
     Cells[1,0]:='X';Cells[2,0]:='Y';Cells[3,0]:='Z';
     for jj:=1 to MaxTaons do
         Cells[0,jj]:=IntToStr(jj);

     for ii := 1 to MaxTaons do
     for jj:= 1 to RowCount do
     if Dao[ii]
        then
        case jj of
         1:Cells[jj,ii] := FloatToStr(Xo[ii]);
         2:Cells[jj,ii] := FloatToStr(Yo[ii]);
         3:Cells[jj,ii] := FloatToStr(Zo[ii]);
        end
        else
            Cells[jj,ii] := '';
     end
     else
     begin
     Cells[1,0]:='u(x)';Cells[2,0]:='u(y)';Cells[3,0]:='u(z)';
     for jj:=1 to MaxTaons do
         Cells[0,jj]:=IntToStr(jj);

     for ii := 1 to MaxTaons do
     for jj:= 1 to RowCount do
     if Dao[ii]
        then
        case jj of
         1:Cells[jj,ii] := FloatToStr(Vo[ii]);
         2:Cells[jj,ii] := FloatToStr(Uo[ii]);
         3:Cells[jj,ii] := FloatToStr(Wo[ii]);
         end
        else
            Cells[jj,ii] := '';
     end;
end;
procedure DrawLine;
var n             :integer;
begin
Ffsincos;
  for n:=1 to MaxTaons do
  if Dao[n] then
      begin
          q:=f11*x[n]+f12*y[n]+f13*z[n];
          w:=f21*x[n]+f22*y[n]+f23*z[n];
          e:=f31*x[n]+f32*y[n]+f33*z[n];
          xs[n]:=q;ys[n]:=w;zs[n]:=e;
          xp:=xs[n]*xl/2;
          yp:=ys[n]*xl/2;
          zp:=zs[n]*xl/2;
          uu:=xp+u0+xt;
          vv:=zp+v0+zt;
          u[n]:=round(uu);v[n]:=round(vv);
      end;

ClearCub;
with MainForm do
     with Canvas do
          begin
             for n:=1 to MaxTaons do
                     if Dao[n] then
                       begin
                          if (n<=(MaxTaons-50)) then
                         begin
                          Pixels[u[n],v[n]]:=clLime;
                          Pixels[u[n]+1,v[n]]:=clLime;
                          Pixels[u[n],v[n]+1]:=clLime;
                          Pixels[u[n]+1,v[n]+1]:=clLime;
                         end;
                          if ((n>(MaxTaons-50)) and (n<=(MaxTaons-20))) then
                         begin
                          Pixels[u[n],v[n]]:=clYellow;
                          Pixels[u[n]+1,v[n]]:=clYellow;
                          Pixels[u[n],v[n]+1]:=clYellow;
                          Pixels[u[n]+1,v[n]+1]:=clYellow;
                         end;
                          if (n>(MaxTaons-20)) then
                         begin
                          Pixels[u[n],v[n]]:=clRed;
                          Pixels[u[n]+1,v[n]]:=clRed;
                          Pixels[u[n],v[n]+1]:=clRed;
                          Pixels[u[n]+1,v[n]+1]:=clRed;
                         end;
                       end;
                if ShowNumbersOfPunkts then
                   for n:=1 to MaxTaons do
                     if Dao[n] then
                       begin
                         if (n<=(MaxTaons-50)) then
                         Font.Color:=clLime;
                         if ((n>(MaxTaons-50)) and (n<=(MaxTaons-20))) then
                         Font.Color:=clYellow;
                         if (n>(MaxTaons-20)) then
                         Font.Color:=clRed;
                         TextOut(u[n]+2,v[n]+2,IntToStr(n));
                       end;
          end;
end;
procedure ShowSpiral;
  procedure Proection(Maxn:integer);
  var n:integer;
  begin
  for n:=1 to Maxn do
      begin
          q:=f11*x[n]+f12*y[n]+f13*z[n];
          w:=f21*x[n]+f22*y[n]+f23*z[n];
          e:=f31*x[n]+f32*y[n]+f33*z[n];
          x[n]:=q;y[n]:=w;z[n]:=e;
          xp:=x[n]*xl/2;
          yp:=y[n]*xl/2;
          zp:=z[n]*xl/2;
          uu:=xp+u0+xt;
          vv:=zp+v0+zt;
          u[n]:=round(uu);v[n]:=round(vv);
      end;
  end;//Proection
begin
fsincos;
ClearCub;
with MainForm do
     with Canvas do
     case TypeSpiral of
     0:;
     1:
          begin
          Proection(19);
          Pen.Color:=clWhite;
          // first triangle
          moveto(u[1],v[1]);lineto(u[2],v[2]); // Axis
          Pen.Color:=clRed;
          lineto(u[3],v[3]);
          lineto(u[1],v[1]);
          // Tetra
          moveto(u[1],v[1]);lineto(u[4],v[4]);
          moveto(u[2],v[2]);lineto(u[4],v[4]);
          lineto(u[3],v[3]);lineto(u[4],v[4]);
          // 2-Tetra
          moveto(u[1],v[1]);lineto(u[5],v[5]);
          moveto(u[2],v[2]);lineto(u[5],v[5]);
          lineto(u[3],v[3]);lineto(u[5],v[5]);
          // 3-Tetra
          moveto(u[1],v[1]);lineto(u[6],v[6]);
          moveto(u[2],v[2]);lineto(u[6],v[6]);
          lineto(u[6],v[6]);lineto(u[5],v[5]);
          // 4-Tetra
          moveto(u[1],v[1]);lineto(u[7],v[7]);
          moveto(u[2],v[2]);lineto(u[7],v[7]);
          lineto(u[7],v[7]);lineto(u[6],v[6]);
          // 5-Tetra
          moveto(u[2],v[2]);lineto(u[8],v[8]);
          moveto(u[6],v[6]);lineto(u[8],v[8]);
          lineto(u[7],v[7]);lineto(u[8],v[8]);
          // 6-Tetra
          moveto(u[2],v[2]);lineto(u[9],v[9]);
          moveto(u[6],v[6]);lineto(u[9],v[9]);
          lineto(u[8],v[8]);lineto(u[9],v[9]);
          // 7-Tetra
          Pen.Color:=clWhite;  // Axis
          moveto(u[2],v[2]);lineto(u[10],v[10]);
          Pen.Color:=clRed;
          moveto(u[8],v[8]);lineto(u[10],v[10]);
          lineto(u[9],v[9]);lineto(u[10],v[10]);
          // 8-Tetra
          moveto(u[2],v[2]);lineto(u[11],v[11]);
          moveto(u[8],v[8]);lineto(u[11],v[11]);
          lineto(u[10],v[10]);lineto(u[11],v[11]);
          // 9-Tetra
          moveto(u[2],v[2]);lineto(u[12],v[12]);
          moveto(u[10],v[10]);lineto(u[12],v[12]);
          lineto(u[11],v[11]);lineto(u[12],v[12]);
          // 10-Tetra
          moveto(u[2],v[2]);lineto(u[13],v[13]);
          moveto(u[10],v[10]);lineto(u[13],v[13]);
          lineto(u[12],v[12]);lineto(u[13],v[13]);
          // 11-Tetra
          moveto(u[10],v[10]);lineto(u[14],v[14]);
          moveto(u[12],v[12]);lineto(u[14],v[14]);
          lineto(u[13],v[13]);lineto(u[14],v[14]);
          // 12-Tetra
          moveto(u[10],v[10]);lineto(u[15],v[15]);
          moveto(u[12],v[12]);lineto(u[15],v[15]);
          lineto(u[14],v[14]);lineto(u[15],v[15]);
          // 13-Tetra
          Pen.Color:=clWhite;  // Axis
          moveto(u[10],v[10]);lineto(u[16],v[16]);
          Pen.Color:=clRed;
          moveto(u[14],v[14]);lineto(u[16],v[16]);
          lineto(u[15],v[15]);lineto(u[16],v[16]);
          // 14-Tetra
          moveto(u[10],v[10]);lineto(u[17],v[17]);
          moveto(u[14],v[14]);lineto(u[17],v[17]);
          lineto(u[16],v[16]);lineto(u[17],v[17]);
          // 15-Tetra
          moveto(u[10],v[10]);lineto(u[18],v[18]);
          moveto(u[16],v[16]);lineto(u[18],v[18]);
          lineto(u[17],v[17]);lineto(u[18],v[18]);
          // 16-Tetra
          moveto(u[10],v[10]);lineto(u[19],v[19]);
          moveto(u[16],v[16]);lineto(u[19],v[19]);
          lineto(u[18],v[18]);lineto(u[19],v[19]);

          if ShowNumbersOfPunkts then
             begin
             Font.Color:=clLime;
             TextOut(u[1],v[1],'1');
             TextOut(u[2],v[2],'2');
             TextOut(u[3],v[3],'3');
             TextOut(u[4],v[4],'4');
             TextOut(u[5],v[5],'5');
             TextOut(u[6],v[6],'6');
             TextOut(u[7],v[7],'7');
             TextOut(u[8],v[8],'8');
             TextOut(u[9],v[9],'9');
             TextOut(u[10],v[10],'10');
             TextOut(u[11],v[11],'11');
             TextOut(u[12],v[12],'12');
             TextOut(u[13],v[13],'13');
             TextOut(u[14],v[14],'14');
             TextOut(u[15],v[15],'15');
             TextOut(u[16],v[16],'16');
             TextOut(u[17],v[17],'17');
             TextOut(u[18],v[18],'18');
             TextOut(u[19],v[19],'19');
             end;
          end;
     2:;
     3:;
     end;//case
end;//ShowSpiral
procedure Game(Num:Longint);
var
   i                    // Number of partikle
                          :Longint;

   dXv, dYv, dZv,         // Prirashenie skorosti
   dX, dY, dZ             // Prirashenie koordinat
                          :extended;

   function XUsko(im:integer):extended;
   // Poluchaem uskorenie po osi X
   var j :integer;
       Xia :extended;
       Ao1, Bo1, Co1, Do1, Fo1, Go1 :extended;
       Ao2, Bo2, Co2, Do2, Fo2, Go2 :extended;
       Ao3, Bo3, Co3, Do3, Fo3, Go3 :extended;
       p1c1, p1c2, p1c3,
       p2c1, p2c2, p2c3,
       p3c1, p3c2, p3c3 :extended;
       s:extended;
   begin //1
   Xia:=0;
   Ao1:=A1;
   Bo1:=1.029/B1;
   Co1:=1.029/C1;
   Do1:=1.029/D1;
   Fo1:=1.029/F1;
   Go1:=1.029/G1;
   Ao2:=A2;
   Bo2:=1.029/B2;
   Co2:=1.029/C2;
   Do2:=1.029/D2;
   Fo2:=1.029/F2;
   Go2:=1.029/G2;
   Ao3:=A3;
   Bo3:=1.029/B3;
   Co3:=1.029/C3;
   Do3:=1.029/D3;
   Fo3:=1.029/F3;
   Go3:=1.029/G3;
   for j:=1 to MaxTaons do
    if Dao[j] then
     if j<>i then
      begin //2
      s := Sqrt(Sqr(Xo[i]-Xo[j])+Sqr(Yo[i]-Yo[j])+Sqr(Zo[i]-Zo[j]));
       if (j<=(MaxTaons-50)) then
        begin //3
          p1c1:=-(0.945/0.2)*2*St(18,(0.945/0.2)*(s/(4*Bo1)))* (1+19*ln((0.945/0.2)*(s/(4*Bo1))))*St(-St(19,(0.945/0.2)*(s/(4*Bo1))),(0.945/0.2)*(s/(4*Bo1)));
//          -125*St(-14,10)*(2.7/30)*75*St(-2,(2.7/30)*(s/(4*Bo1)))*(1-ln((2.7/30)*(s/(4*Bo1))))*St(75*St(-1,(2.7/30)*(s/(4*Bo1))),(2.7/30)*(s/(4*Bo1)));
          p1c2:=-( St(-1,0.1*Bo1)* St(-2,s)*(2.5- St(20,Bo1*s))*(1-ln(Bo1*s))-200*Bo1*St(18,Bo1*s)
          *ln(Bo1*s))*St((2.5-St(20,Bo1*s))*St(-1,0.1*Bo1*s),Bo1*s);
          p1c3:=-( St(-1,0.1*Co1)* St(-2,s)*(2.5- St(20,Co1*s))*(1-ln(Co1*s))-200*Co1*St(18,Co1*s)
          *ln(Co1*s))*St((2.5-St(20,Co1*s))*St(-1,0.1*Co1*s),Co1*s)

          -( St(-1,0.1*Do1)* St(-2,s)*(2.5- St(20,Do1*s))*(1-ln(Do1*s))-200*Do1*St(18,Do1*s)
          *ln(Do1*s))*St((2.5-St(20,Do1*s))*St(-1,0.1*Do1*s),Do1*s)

          -( St(-1,0.1*Fo1)* St(-2,s)*(2.5- St(20,Fo1*s))*(1-ln(Fo1*s))-200*Fo1*St(18,Fo1*s)
          *ln(Fo1*s))*St((2.5-St(20,Fo1*s))*St(-1,0.1*Fo1*s),Fo1*s)

          -( St(-1,0.1*Go1)* St(-2,s)*(2.5- St(20,Go1*s))*(1-ln(Go1*s))-200*Go1*St(18,Go1*s)
          *ln(Go1*s))*St((2.5-St(20,Go1*s))*St(-1,0.1*Go1*s),Go1*s);
         Xia := Xia +
         (-1)*(Xo[i]-Xo[j])/s * Ao1* (p1c1+p1c2+p1c3);
        end; //3
       if ((j>(MaxTaons-50)) and (j<=(MaxTaons-20))) then
        begin  //3
          p2c1:=-(0.945/0.2)*2*St(18,(0.945/0.2)*(s/(4*Bo2)))* (1+19*ln((0.945/0.2)*(s/(4*Bo2))))*St(-St(19,(0.945/0.2)*(s/(4*Bo2))),(0.945/0.2)*(s/(4*Bo2)));
//          -125*St(-14,10)*(2.7/30)*75*St(-2,(2.7/30)*(s/(4*Bo2)))*(1-ln((2.7/30)*(s/(4*Bo2))))*St(75*St(-1,(2.7/30)*(s/(4*Bo2))),(2.7/30)*(s/(4*Bo2)));
          p2c2:=-( St(-1,0.1*Bo2)* St(-2,s)*(2.5- St(20,Bo2*s))*(1-ln(Bo2*s))-200*Bo2*St(18,Bo2*s)
          *ln(Bo2*s))*St((2.5-St(20,Bo2*s))*St(-1,0.1*Bo2*s),Bo2*s);
          p2c3:=-( St(-1,0.1*Co2)* St(-2,s)*(2.5- St(20,Co2*s))*(1-ln(Co2*s))-200*Co2*St(18,Co2*s)
          *ln(Co2*s))*St((2.5-St(20,Co2*s))*St(-1,0.1*Co2*s),Co2*s)

          -( St(-1,0.1*Do2)* St(-2,s)*(2.5- St(20,Do2*s))*(1-ln(Do2*s))-200*Do2*St(18,Do2*s)
          *ln(Do2*s))*St((2.5-St(20,Do2*s))*St(-1,0.1*Do2*s),Do2*s)

          -( St(-1,0.1*Fo2)* St(-2,s)*(2.5- St(20,Fo2*s))*(1-ln(Fo2*s))-200*Fo2*St(18,Fo2*s)
          *ln(Fo2*s))*St((2.5-St(20,Fo2*s))*St(-1,0.1*Fo2*s),Fo2*s)

          -( St(-1,0.1*Go2)* St(-2,s)*(2.5- St(20,Go2*s))*(1-ln(Go2*s))-200*Go2*St(18,Go2*s)
          *ln(Go2*s))*St((2.5-St(20,Go2*s))*St(-1,0.1*Go2*s),Go2*s);
         Xia := Xia +
         (-1)*(Xo[i]-Xo[j])/s * Ao2* (p2c1+p2c2+p2c3);
        end; //3
       if (j>(MaxTaons-20)) then
        begin  //3
          p3c1:=-(0.945/0.2)*2*St(18,(0.945/0.2)*(s/(4*Bo3)))* (1+19*ln((0.945/0.2)*(s/(4*Bo3))))*St(-St(19,(0.945/0.2)*(s/(4*Bo3))),(0.945/0.2)*(s/(4*Bo3)));
//          -125*St(-14,10)*(2.7/30)*75*St(-2,(2.7/30)*(s/(4*Bo3)))*(1-ln((2.7/30)*(s/(4*Bo3))))*St(75*St(-1,(2.7/30)*(s/(4*Bo3))),(2.7/30)*(s/(4*Bo3)));
          p3c2:=-( St(-1,0.1*Bo3)* St(-2,s)*(2.5- St(20,Bo3*s))*(1-ln(Bo3*s))-200*Bo3*St(18,Bo3*s)
          *ln(Bo3*s))*St((2.5-St(20,Bo3*s))*St(-1,0.1*Bo3*s),Bo3*s);
          p3c3:=-( St(-1,0.1*Co3)* St(-2,s)*(2.5- St(20,Co3*s))*(1-ln(Co3*s))-200*Co3*St(18,Co3*s)
          *ln(Co3*s))*St((2.5-St(20,Co3*s))*St(-1,0.1*Co3*s),Co3*s)

          -( St(-1,0.1*Do3)* St(-2,s)*(2.5- St(20,Do3*s))*(1-ln(Do3*s))-200*Do3*St(18,Do2*s)
          *ln(Do3*s))*St((2.5-St(20,Do3*s))*St(-1,0.1*Do3*s),Do3*s)

          -( St(-1,0.1*Fo3)* St(-2,s)*(2.5- St(20,Fo3*s))*(1-ln(Fo3*s))-200*Fo3*St(18,Fo3*s)
          *ln(Fo3*s))*St((2.5-St(20,Fo3*s))*St(-1,0.1*Fo3*s),Fo3*s)

          -( St(-1,0.1*Go3)* St(-2,s)*(2.5- St(20,Go3*s))*(1-ln(Go3*s))-200*Go3*St(18,Go3*s)
          *ln(Go3*s))*St((2.5-St(20,Go3*s))*St(-1,0.1*Go3*s),Go3*s);
         Xia := Xia +
         (-1)*(Xo[i]-Xo[j])/s * Ao3* (p3c1+p3c2+p3c3);
        end; //3
      end;   //2
    XUsko:=Xia;
   end; //1
   function YUsko(im:integer):extended;
   // Poluchaem uskorenie po osi Y
   var j :integer;
       Yia :extended;
       Ao1, Bo1, Co1, Do1, Fo1, Go1 :extended;
       Ao2, Bo2, Co2, Do2, Fo2, Go2 :extended;
       Ao3, Bo3, Co3, Do3, Fo3, Go3 :extended;
       p1c1, p1c2, p1c3,
       p2c1, p2c2, p2c3,
       p3c1, p3c2, p3c3 :extended;
       s:extended;
   begin //1
   Yia:=0;
   Ao1:=A1;
   Bo1:=1.029/B1;
   Co1:=1.029/C1;
   Do1:=1.029/D1;
   Fo1:=1.029/F1;
   Ao2:=A2;
   Bo2:=1.029/B2;
   Co2:=1.029/C2;
   Do2:=1.029/D2;
   Fo2:=1.029/F2;
   Ao3:=A3;
   Bo3:=1.029/B3;
   Co3:=1.029/C3;
   Do3:=1.029/D3;
   Fo3:=1.029/F3;
   for j:=1 to MaxTaons do
    if Dao[j] then
     if j<>i then
      begin //2
      s := Sqrt(Sqr(Xo[i]-Xo[j])+Sqr(Yo[i]-Yo[j])+Sqr(Zo[i]-Zo[j]));
       if (j<=(MaxTaons-50)) then
        begin //3
          p1c1:=-(0.945/0.2)*2*St(18,(0.945/0.2)*(s/(4*Bo1)))* (1+19*ln((0.945/0.2)*(s/(4*Bo1))))*St(-St(19,(0.945/0.2)*(s/(4*Bo1))),(0.945/0.2)*(s/(4*Bo1)));
//          -125*St(-14,10)*(2.7/30)*75*St(-2,(2.7/30)*(s/(4*Bo1)))*(1-ln((2.7/30)*(s/(4*Bo1))))*St(75*St(-1,(2.7/30)*(s/(4*Bo1))),(2.7/30)*(s/(4*Bo1)));
          p1c2:=-( St(-1,0.1*Bo1)* St(-2,s)*(2.5- St(20,Bo1*s))*(1-ln(Bo1*s))-200*Bo1*St(18,Bo1*s)
          *ln(Bo1*s))*St((2.5-St(20,Bo1*s))*St(-1,0.1*Bo1*s),Bo1*s);
          p1c3:=-( St(-1,0.1*Co1)* St(-2,s)*(2.5- St(20,Co1*s))*(1-ln(Co1*s))-200*Co1*St(18,Co1*s)
          *ln(Co1*s))*St((2.5-St(20,Co1*s))*St(-1,0.1*Co1*s),Co1*s)

          -( St(-1,0.1*Do1)* St(-2,s)*(2.5- St(20,Do1*s))*(1-ln(Do1*s))-200*Do1*St(18,Do1*s)
          *ln(Do1*s))*St((2.5-St(20,Do1*s))*St(-1,0.1*Do1*s),Do1*s)

          -( St(-1,0.1*Fo1)* St(-2,s)*(2.5- St(20,Fo1*s))*(1-ln(Fo1*s))-200*Fo1*St(18,Fo1*s)
          *ln(Fo1*s))*St((2.5-St(20,Fo1*s))*St(-1,0.1*Fo1*s),Fo1*s)

          -( St(-1,0.1*Go1)* St(-2,s)*(2.5- St(20,Go1*s))*(1-ln(Go1*s))-200*Go1*St(18,Go1*s)
          *ln(Go1*s))*St((2.5-St(20,Go1*s))*St(-1,0.1*Go1*s),Go1*s);
         Yia := Yia +
         (-1)*(Yo[i]-Yo[j])/s * Ao1* (p1c1+p1c2+p1c3);
        end; //3
       if ((j>(MaxTaons-50)) and (j<=(MaxTaons-20))) then
        begin  //3
          p2c1:=-(0.945/0.2)*2*St(18,(0.945/0.2)*(s/(4*Bo2)))* (1+19*ln((0.945/0.2)*(s/(4*Bo2))))*St(-St(19,(0.945/0.2)*(s/(4*Bo2))),(0.945/0.2)*(s/(4*Bo2)));
//          -125*St(-14,10)*(2.7/30)*75*St(-2,(2.7/30)*(s/(4*Bo2)))*(1-ln((2.7/30)*(s/(4*Bo2))))*St(75*St(-1,(2.7/30)*(s/(4*Bo2))),(2.7/30)*(s/(4*Bo2)));
          p2c2:=-( St(-1,0.1*Bo2)* St(-2,s)*(2.5- St(20,Bo2*s))*(1-ln(Bo2*s))-200*Bo2*St(18,Bo2*s)
          *ln(Bo2*s))*St((2.5-St(20,Bo2*s))*St(-1,0.1*Bo2*s),Bo2*s);
          p2c3:=-( St(-1,0.1*Co2)* St(-2,s)*(2.5- St(20,Co2*s))*(1-ln(Co2*s))-200*Co2*St(18,Co2*s)
          *ln(Co2*s))*St((2.5-St(20,Co2*s))*St(-1,0.1*Co2*s),Co2*s)

          -( St(-1,0.1*Do2)* St(-2,s)*(2.5- St(20,Do2*s))*(1-ln(Do2*s))-200*Do2*St(18,Do2*s)
          *ln(Do2*s))*St((2.5-St(20,Do2*s))*St(-1,0.1*Do2*s),Do2*s)

          -( St(-1,0.1*Fo2)* St(-2,s)*(2.5- St(20,Fo2*s))*(1-ln(Fo2*s))-200*Fo2*St(18,Fo2*s)
          *ln(Fo2*s))*St((2.5-St(20,Fo2*s))*St(-1,0.1*Fo2*s),Fo2*s)

          -( St(-1,0.1*Go2)* St(-2,s)*(2.5- St(20,Go2*s))*(1-ln(Go2*s))-200*Go2*St(18,Go2*s)
          *ln(Go2*s))*St((2.5-St(20,Go2*s))*St(-1,0.1*Go2*s),Go2*s);
         Yia := Yia +
         (-1)*(Yo[i]-Yo[j])/s * Ao2* (p2c1+p2c2+p2c3);
        end; //3
       if (j>(MaxTaons-20)) then
        begin  //3
          p3c1:=-(0.945/0.2)*2*St(18,(0.945/0.2)*(s/(4*Bo3)))* (1+19*ln((0.945/0.2)*(s/(4*Bo3))))*St(-St(19,(0.945/0.2)*(s/(4*Bo3))),(0.945/0.2)*(s/(4*Bo3)));
//          -125*St(-14,10)*(2.7/30)*75*St(-2,(2.7/30)*(s/(4*Bo3)))*(1-ln((2.7/30)*(s/(4*Bo3))))*St(75*St(-1,(2.7/30)*(s/(4*Bo3))),(2.7/30)*(s/(4*Bo3)));
          p3c2:=-( St(-1,0.1*Bo3)* St(-2,s)*(2.5- St(20,Bo3*s))*(1-ln(Bo3*s))-200*Bo3*St(18,Bo3*s)
          *ln(Bo3*s))*St((2.5-St(20,Bo3*s))*St(-1,0.1*Bo3*s),Bo3*s);
          p3c3:=-( St(-1,0.1*Co3)* St(-2,s)*(2.5- St(20,Co3*s))*(1-ln(Co3*s))-200*Co3*St(18,Co3*s)
          *ln(Co3*s))*St((2.5-St(20,Co3*s))*St(-1,0.1*Co3*s),Co3*s)

          -( St(-1,0.1*Do3)* St(-2,s)*(2.5- St(20,Do3*s))*(1-ln(Do3*s))-200*Do3*St(18,Do2*s)
          *ln(Do3*s))*St((2.5-St(20,Do3*s))*St(-1,0.1*Do3*s),Do3*s)

          -( St(-1,0.1*Fo3)* St(-2,s)*(2.5- St(20,Fo3*s))*(1-ln(Fo3*s))-200*Fo3*St(18,Fo3*s)
          *ln(Fo3*s))*St((2.5-St(20,Fo3*s))*St(-1,0.1*Fo3*s),Fo3*s)

          -( St(-1,0.1*Go3)* St(-2,s)*(2.5- St(20,Go3*s))*(1-ln(Go3*s))-200*Go3*St(18,Go3*s)
          *ln(Go3*s))*St((2.5-St(20,Go3*s))*St(-1,0.1*Go3*s),Go3*s);
         Yia := Yia +
         (-1)*(Yo[i]-Yo[j])/s * Ao3* (p3c1+p3c2+p3c3);
        end; //3
      end;   //2
    YUsko:=Yia;
   end; //1

   function ZUsko(im:integer):extended;
   // Poluchaem uskorenie po osi Z
   var j :integer;
       Zia :extended;
       Ao1, Bo1, Co1, Do1, Fo1, Go1 :extended;
       Ao2, Bo2, Co2, Do2, Fo2, Go2 :extended;
       Ao3, Bo3, Co3, Do3, Fo3, Go3 :extended;
       p1c1, p1c2, p1c3,
       p2c1, p2c2, p2c3,
       p3c1, p3c2, p3c3 :extended;
       s:extended;
   begin //1
   Zia:=0;
   Ao1:=A1;
   Bo1:=1.029/B1;
   Co1:=1.029/C1;
   Do1:=1.029/D1;
   Fo1:=1.029/F1;
   Ao2:=A2;
   Bo2:=1.029/B2;
   Co2:=1.029/C2;
   Do2:=1.029/D2;
   Fo2:=1.029/F2;
   Ao3:=A3;
   Bo3:=1.029/B3;
   Co3:=1.029/C3;
   Do3:=1.029/D3;
   Fo3:=1.029/F3;
   for j:=1 to MaxTaons do
    if Dao[j] then
     if j<>i then
      begin //2
      s := Sqrt(Sqr(Xo[i]-Xo[j])+Sqr(Yo[i]-Yo[j])+Sqr(Zo[i]-Zo[j]));
       if (j<=(MaxTaons-50)) then
        begin //3
          p1c1:=-(0.945/0.2)*2*St(18,(0.945/0.2)*(s/(4*Bo1)))* (1+19*ln((0.945/0.2)*(s/(4*Bo1))))*St(-St(19,(0.945/0.2)*(s/(4*Bo1))),(0.945/0.2)*(s/(4*Bo1)));
//          -125*St(-14,10)*(2.7/30)*75*St(-2,(2.7/30)*(s/(4*Bo1)))*(1-ln((2.7/30)*(s/(4*Bo1))))*St(75*St(-1,(2.7/30)*(s/(4*Bo1))),(2.7/30)*(s/(4*Bo1)));
          p1c2:=-( St(-1,0.1*Bo1)* St(-2,s)*(2.5- St(20,Bo1*s))*(1-ln(Bo1*s))-200*Bo1*St(18,Bo1*s)
          *ln(Bo1*s))*St((2.5-St(20,Bo1*s))*St(-1,0.1*Bo1*s),Bo1*s);
          p1c3:=-( St(-1,0.1*Co1)* St(-2,s)*(2.5- St(20,Co1*s))*(1-ln(Co1*s))-200*Co1*St(18,Co1*s)
          *ln(Co1*s))*St((2.5-St(20,Co1*s))*St(-1,0.1*Co1*s),Co1*s)

          -( St(-1,0.1*Do1)* St(-2,s)*(2.5- St(20,Do1*s))*(1-ln(Do1*s))-200*Do1*St(18,Do1*s)
          *ln(Do1*s))*St((2.5-St(20,Do1*s))*St(-1,0.1*Do1*s),Do1*s)

          -( St(-1,0.1*Fo1)* St(-2,s)*(2.5- St(20,Fo1*s))*(1-ln(Fo1*s))-200*Fo1*St(18,Fo1*s)
          *ln(Fo1*s))*St((2.5-St(20,Fo1*s))*St(-1,0.1*Fo1*s),Fo1*s)

          -( St(-1,0.1*Go1)* St(-2,s)*(2.5- St(20,Go1*s))*(1-ln(Go1*s))-200*Go1*St(18,Go1*s)
          *ln(Go1*s))*St((2.5-St(20,Go1*s))*St(-1,0.1*Go1*s),Go1*s);
         Zia := Zia +
         (-1)*(Zo[i]-Zo[j])/s * Ao1* (p1c1+p1c2+p1c3);
        end; //3
       if ((j>(MaxTaons-50)) and (j<=(MaxTaons-20))) then
        begin  //3
          p2c1:=-(0.945/0.2)*2*St(18,(0.945/0.2)*(s/(4*Bo2)))* (1+19*ln((0.945/0.2)*(s/(4*Bo2))))*St(-St(19,(0.945/0.2)*(s/(4*Bo2))),(0.945/0.2)*(s/(4*Bo2)));
//          -125*St(-14,10)*(2.7/30)*75*St(-2,(2.7/30)*(s/(4*Bo2)))*(1-ln((2.7/30)*(s/(4*Bo2))))*St(75*St(-1,(2.7/30)*(s/(4*Bo2))),(2.7/30)*(s/(4*Bo2)));
          p2c2:=-( St(-1,0.1*Bo2)* St(-2,s)*(2.5- St(20,Bo2*s))*(1-ln(Bo2*s))-200*Bo2*St(18,Bo2*s)
          *ln(Bo2*s))*St((2.5-St(20,Bo2*s))*St(-1,0.1*Bo2*s),Bo2*s);
          p2c3:=-( St(-1,0.1*Co2)* St(-2,s)*(2.5- St(20,Co2*s))*(1-ln(Co2*s))-200*Co2*St(18,Co2*s)
          *ln(Co2*s))*St((2.5-St(20,Co2*s))*St(-1,0.1*Co2*s),Co2*s)

          -( St(-1,0.1*Do2)* St(-2,s)*(2.5- St(20,Do2*s))*(1-ln(Do2*s))-200*Do2*St(18,Do2*s)
          *ln(Do2*s))*St((2.5-St(20,Do2*s))*St(-1,0.1*Do2*s),Do2*s)

          -( St(-1,0.1*Fo2)* St(-2,s)*(2.5- St(20,Fo2*s))*(1-ln(Fo2*s))-200*Fo2*St(18,Fo2*s)
          *ln(Fo2*s))*St((2.5-St(20,Fo2*s))*St(-1,0.1*Fo2*s),Fo2*s)

          -( St(-1,0.1*Go2)* St(-2,s)*(2.5- St(20,Go2*s))*(1-ln(Go2*s))-200*Go2*St(18,Go2*s)
          *ln(Go2*s))*St((2.5-St(20,Go2*s))*St(-1,0.1*Go2*s),Go2*s);
         Zia := Zia +
         (-1)*(Zo[i]-Zo[j])/s * Ao2* (p2c1+p2c2+p2c3);
        end; //3
       if (j>(MaxTaons-20)) then
        begin  //3
          p3c1:=-(0.945/0.2)*2*St(18,(0.945/0.2)*(s/(4*Bo3)))* (1+19*ln((0.945/0.2)*(s/(4*Bo3))))*St(-St(19,(0.945/0.2)*(s/(4*Bo3))),(0.945/0.2)*(s/(4*Bo3)));
//          -125*St(-14,10)*(2.7/30)*75*St(-2,(2.7/30)*(s/(4*Bo3)))*(1-ln((2.7/30)*(s/(4*Bo3))))*St(75*St(-1,(2.7/30)*(s/(4*Bo3))),(2.7/30)*(s/(4*Bo3)));
          p3c2:=-( St(-1,0.1*Bo3)* St(-2,s)*(2.5- St(20,Bo3*s))*(1-ln(Bo3*s))-200*Bo3*St(18,Bo3*s)
          *ln(Bo3*s))*St((2.5-St(20,Bo3*s))*St(-1,0.1*Bo3*s),Bo3*s);
          p3c3:=-( St(-1,0.1*Co3)* St(-2,s)*(2.5- St(20,Co3*s))*(1-ln(Co3*s))-200*Co3*St(18,Co3*s)
          *ln(Co3*s))*St((2.5-St(20,Co3*s))*St(-1,0.1*Co3*s),Co3*s)

          -( St(-1,0.1*Do3)* St(-2,s)*(2.5- St(20,Do3*s))*(1-ln(Do3*s))-200*Do3*St(18,Do2*s)
          *ln(Do3*s))*St((2.5-St(20,Do3*s))*St(-1,0.1*Do3*s),Do3*s)

          -( St(-1,0.1*Fo3)* St(-2,s)*(2.5- St(20,Fo3*s))*(1-ln(Fo3*s))-200*Fo3*St(18,Fo3*s)
          *ln(Fo3*s))*St((2.5-St(20,Fo3*s))*St(-1,0.1*Fo3*s),Fo3*s)

          -( St(-1,0.1*Go3)* St(-2,s)*(2.5- St(20,Go3*s))*(1-ln(Go3*s))-200*Go3*St(18,Go3*s)
          *ln(Go3*s))*St((2.5-St(20,Go3*s))*St(-1,0.1*Go3*s),Go3*s);
         Zia := Zia +
         (-1)*(Zo[i]-Zo[j])/s * Ao3* (p3c1+p3c2+p3c3);
        end; //3
      end;   //2
    ZUsko:=Zia;
   end; //1
function Co :extended;
   begin
     if MainForm.Cool.Checked  then
       Co:=0.99
     else
       Co:=1;
   end;
begin // Game //
repeat
   inc(Num);

   // Calculation of new value of koord and velo.
   for i:=1 to MaxTaons do
   if Dao[i] then
       begin
       // X
       dXv := XUsko(i) * dt;    // + velo
       Vn[i] := Co*Vn[i] + dXv;    // New x velo
       dX := Vn[i] * dt;        // + koord
       Xn[i] := Xn[i] + dX;     // New koordinat

       // Y
       dYv := YUsko(i) * dt;    // + velo
       Un[i] := Co*Un[i] + dYv;    // New x velo
       dY := Un[i] * dt;        // + koord
       Yn[i] := Yn[i] + dY;     // New koordinat

       // Z
       dZv := ZUsko(i) * dt;    // + velo
       Wn[i] := Co*Wn[i] + dZv;    // New x velo
       dZ := Wn[i] * dt;        // + koord
       Zn[i] := Zn[i] + dZ;     // New koordinat

       end;


   // The new value send to Xo and Vo
   for i:=1 to MaxTaons do
   if Dao[i] then
       begin
       Xo[i]:=Xn[i]; Vo[i]:=Vn[i];
       Yo[i]:=Yn[i]; Uo[i]:=Un[i];
       Zo[i]:=Zn[i]; Wo[i]:=Wn[i];
       x[i]:=Xn[i];
       y[i]:=Yn[i];
       z[i]:=Zn[i];
       end;

  Time:=Num;
   if ShowLabelTime then
      MainForm.LTime.Caption:=IntToStr(Time);

   DrawLine;
   if MainForm.ShowList.Checked then ShowTable;
   //
   Application.ProcessMessages;
until Stop;
end;//Game;

// End of graphical proc

procedure TMainForm.Exit1Click(Sender: TObject);
begin
Close
end;

procedure TMainForm.FormPaint(Sender: TObject);
begin
     u0:=Round(width/2);v0:=Round(Pan.Top/2);
     if Spiral
        then
            begin
            ShowSpiral;
            end
        else
            begin
            ThisName:=StartFile;
            DrawLine;
            ShowTable;
            end;
end;

procedure TMainForm.TimerTimer(Sender: TObject);
begin
if Spin then
     if Spiral
        then ShowSpiral
        else DrawLine;
end;

procedure TMainForm.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if Button = mbRight
   then
       begin
       RStartX:=X;
       RStartY:=Y;
       end
   else
       begin
       LStartX:=X;
       LStartY:=Y;
       end;
end;

procedure TMainForm.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if Button = mbRight
   then
       begin
       if RStartX<X then k:=k-KoUgol*(X-RStartX);
       if RStartX>X then k:=k+KoUgol*(RStartX-X);
       if RStartY<Y then xl:=xl-KoRass*(Y-RStartY);
       if RStartY>Y then xl:=xl+KoRass*(RStartY-Y);
       end
   else
       begin
       if LStartX<X then l:=l-KoUgol*(X-LStartX);
       if LStartX>X then l:=l+KoUgol*(LStartX-X);
       if LStartY<Y then j:=j+KoUgol*(Y-LStartY);
       if LStartY>Y then j:=j-KoUgol*(LStartY-Y);
       end;
     if Spiral
        then ShowSpiral
        else
            begin
            if Button = mbRight
               then
                   begin
                   ks:=ks+k;
                   end
               else
                   begin
                   ls:=ls+l;
                   js:=js+j;
                   end;
            DrawLine;
            k:=0;l:=0;j:=0;
            end;
  if not ShowSpin.Checked then begin k:=0;l:=0;j:=0 end;
end;

procedure TMainForm.ShowSpinClick(Sender: TObject);
begin
if ShowSpin.Checked
   then
       begin
       Spin:=false;
       ShowSpin.Checked:=false;
       end
   else
       begin
       Spin:=true;
       ShowSpin.Checked:=true;
       end
end;

procedure TMainForm.FormCreate(Sender: TObject);
var n:integer;
begin
     u0:=Round(width/2);v0:=Round(Pan.Top/2);
     xl:=120;
     j:=0;k:=0;l:=0;
     Spiral:=true;
     //Power:=false;
     MaxTaons:=MaxPunkt;
     TypeSpiral:=1;
     fsincos;
     AssignFile(FStartFile,'C:\Start.-bs1-');
     {$I-}
     Reset(FStartFile);
     {$I+}
     if IOResult=0
        then
            begin
            Read(FStartFile,StartFile);
            CloseFile(FStartFile);
            if StartFile=''
               then
                   begin
                   CreateFigure;
                   ThisName:='ThetraSpiral';
                   end
               else
                   begin
                   Spiral:=false;
                   Go.Enabled:=true;
                   ThisName:=StartFile;
                   FName.Text:=ThisName;
                   AssignFile(FTaons,ThisName);
                   {$I-}
                   Reset(FTaons);
                   {$I+}
                   if IOResult=0 then
                   begin
                   Read(FTaons, Taons);
                   CloseFile(FTaons);
                   // Write data of taons
                   dt:=Taons.dt;
                   A1:=Taons.A1;
                   B1:=Taons.B1;
                   C1:=Taons.C1;
                   D1:=Taons.D1;
                   F1:=Taons.F1;
                   G1:=Taons.G1;
                   A2:=Taons.A2;
                   B2:=Taons.B2;
                   C2:=Taons.C2;
                   D2:=Taons.D2;
                   F2:=Taons.F2;
                   G2:=Taons.G2;
                   A3:=Taons.A3;
                   B3:=Taons.B3;
                   C3:=Taons.C3;
                   D3:=Taons.D3;
                   F3:=Taons.F3;
                   G3:=Taons.G3;

                   for n:=1 to MaxTaons do
                       Dao[n]:=Taons.Dao[n];
                   for n:=1 to MaxTaons do
                       begin
                       Xo[n]:=Taons.Xo[n];
                       Yo[n]:=Taons.Yo[n];
                       Zo[n]:=Taons.Zo[n];
                       Vo[n]:=Taons.Vo[n];
                       Uo[n]:=Taons.Uo[n];
                       Wo[n]:=Taons.Wo[n];

                       x[n]:=Xo[n];Xn[n]:=Xo[n];
                       y[n]:=Yo[n];Yn[n]:=Yo[n];
                       z[n]:=Zo[n];Zn[n]:=Zo[n];
                       Vn[n]:=Vo[n];
                       Un[n]:=Uo[n];
                       Wn[n]:=Wo[n];
                       end;
                   // Commentary
                   n:=Length(ThisName);
                   Delete(ThisName,n-3,4);
                   AssignFile(FTaonsText, ThisName+'.txt');
                   {$I-} Reset(FTaonsText); {$I+}
                   if IOResult=0 then
                      begin
                          CloseFile(FTaonsText);
                          Comment.Lines.LoadFromFile(ThisName+'.txt');
                      end;
                   // End commentary
                   end
                   else
                       begin
                       CreateFigure;
                       FName.Text:='The easy square';
                       end
                   end
            end
        else
            begin
            Rewrite(FStartFile);
            CloseFile(FStartFile);
            CreateFigure;
            ThisName:='ThetraSpiral';
            end;
     KoBok:=5;
     KoRass:=3;
     KoUgol:=0.01;
     ShowTable;
     EditDT.Text:=FloatToStr(dt);
     EditA1.Text:=FloatToStr(A1);
     EditB1.Text:=FloatToStr(B1);
     EditC1.Text:=FloatToStr(C1);
     EditD1.Text:=FloatToStr(D1);
     EditF1.Text:=FloatToStr(F1);
     EditG1.Text:=FloatToStr(G1);
     EditA2.Text:=FloatToStr(A2);
     EditB2.Text:=FloatToStr(B2);
     EditC2.Text:=FloatToStr(C2);
     EditD2.Text:=FloatToStr(D2);
     EditF2.Text:=FloatToStr(F2);
     EditG2.Text:=FloatToStr(G2);
     EditA3.Text:=FloatToStr(A3);
     EditB3.Text:=FloatToStr(B3);
     EditC3.Text:=FloatToStr(C3);
     EditD3.Text:=FloatToStr(D3);
     EditF3.Text:=FloatToStr(F3);
     EditG3.Text:=FloatToStr(G3);
     Stop:=true;
     dt:=0.001;     // FalseTime
(*     A1:=1;
     B1:=2.718;
     C1:=5;
     D1:=10;
     F1:=20;
     G1:=30;
     A2:=1;
     B2:=2.718;
     C2:=5;
     D2:=10;
     F2:=20;
     G2:=30;
     A3:=1;
     B3:=2.718;
     C3:=5;
     D3:=10;
     F3:=20;
     G3:=30;
*)
end;

procedure TMainForm.FormResize(Sender: TObject);
var r:integer;
begin
     u0:=Round(width/2);v0:=Round(Pan.Top/2);
     r:=Panel1.Left-5;
     FName.Width:=r+3;
     Comment.Height:=PageControl.Height-29;
     Comment.Width:=r+3;
     PageControl.Width:=r;
     DaonsTable.Width:=r-2;
     DaonsTable.DefaultColWidth:=(r-30) div 6;
     if Spiral
        then ShowSpiral
        else DrawLine;
end;

procedure TMainForm.DaoTeta1Click(Sender: TObject);
begin
     j:=j+KoUgol;
     if Spiral
        then ShowSpiral
        else
            begin
            js:=js+j;
            DrawLine;
            end;
     j:=0;
end;

procedure TMainForm.DaoTetaClick(Sender: TObject);
begin
     j:=j-KoUgol;
     if Spiral
        then ShowSpiral
        else
            begin
            js:=js+j;
            DrawLine;
            end;
     j:=0;
end;

procedure TMainForm.DaoPsiClick(Sender: TObject);
begin
     k:=k-KoUgol;
     if Spiral
        then ShowSpiral
        else
            begin
            ks:=ks+k;
            DrawLine;
            end;
     k:=0;
end;

procedure TMainForm.DaoPsi1Click(Sender: TObject);
begin
     k:=k+KoUgol;
     if Spiral
        then ShowSpiral
        else
            begin
            ks:=ks+k;
            DrawLine;
            end;
     k:=0;
end;

procedure TMainForm.DaoStopClick(Sender: TObject);
begin
     k:=0;j:=0;l:=0;
     if Spiral
        then ShowSpiral
        else DrawLine;
end;

procedure TMainForm.DaoPhi1Click(Sender: TObject);
begin
     l:=l-KoUgol;
     if Spiral
        then ShowSpiral
        else
            begin
            ls:=ls+l;
            DrawLine;
            end;
     l:=0;
end;

procedure TMainForm.DaoPhiClick(Sender: TObject);
begin
     l:=l+KoUgol;
     if Spiral
        then ShowSpiral
        else
            begin
            ls:=ls+l;
            DrawLine;
            end;
     l:=0;
end;

procedure TMainForm.DaoBackClick(Sender: TObject);
begin
     //   
     if xl < 9*KoRass
        then xl:=xl/KoRass
        else xl:=xl-KoRass*3;
     if Spiral
        then ShowSpiral
        else DrawLine;
end;

procedure TMainForm.DaoForvardClick(Sender: TObject);
begin
     //   
     xl:=xl+KoRass*3;
     if Spiral
        then ShowSpiral
        else DrawLine;
end;

procedure TMainForm.TrackBarChange(Sender: TObject);
begin
case TrackBar.Position of
     0:KoUgol:=0.0005;
     1:KoUgol:=0.001;
     2:KoUgol:=0.002;
     3:KoUgol:=0.003;
     4:KoUgol:=0.005;
     5:KoUgol:=0.01;
     6:KoUgol:=0.05;
     7:KoUgol:=0.1;
     8:KoUgol:=0.5;
     9:KoUgol:=1;
     10:KoUgol:=2;
     end;
case TrackBar.Position of
     0:KoRass:=0.5;
     1:KoRass:=1;
     2:KoRass:=2;
     3:KoRass:=3;
     4:KoRass:=5;
     5:KoRass:=7;
     6:KoRass:=10;
     7:KoRass:=15;
     8:KoRass:=20;
     9:KoRass:=30;
     10:KoRass:=50;
     end;
end;

procedure TMainForm.ShowNumbersOfPointsClick(Sender: TObject);
begin
if ShowNumbersOfPoints.Checked
   then
       begin
       ShowNumbersOfPunkts:=false;
       ShowNumbersOfPoints.Checked:=false;
       end
   else
       begin
       ShowNumbersOfPunkts:=true;
       ShowNumbersOfPoints.Checked:=true;
       end;
if Spiral
   then ShowSpiral
   else DrawLine;
end;

procedure TMainForm.Spiral1Click(Sender: TObject);
begin
     Spiral:=true;
     CreateFigure;
     Go.Enabled:=false;
     Null00.Enabled:=false;
     ShowSpiral;
end;

procedure TMainForm.Daons1Click(Sender: TObject);
var n:integer;
begin
     Spiral:=false;
     Go.Enabled:=true;
     Null00.Enabled:=true;
     {$I-}
     Reset(FStartFile);
     {$I+}
     if IOResult=0
        then
            begin
            Read(FStartFile,StartFile);
            CloseFile(FStartFile);
            if StartFile=''
               then
                   begin
                   CreateFigure;
                   ThisName:='This is a stabil structur of taons';
                   CreateFigure;
                   ShowTable;
                   FName.Text:=ThisName;
                   DrawLine;
                   end
               else
                   begin
                   Spiral:=false;
                   ThisName:=StartFile;
                   FName.Text:=ThisName;
                   AssignFile(FTaons,ThisName);
                   {$I-}
                   Reset(FTaons);
                   {$I+}
                   if IOResult=0 then
                   begin
                   Read(FTaons, Taons);
                   CloseFile(FTaons);
                   // Write data of taons
                   dt:=Taons.dt;
                   A1:=Taons.A1;
                   B1:=Taons.B1;
                   C1:=Taons.C1;
                   D1:=Taons.D1;
                   F1:=Taons.F1;
                   G1:=Taons.G1;
                   A2:=Taons.A2;
                   B2:=Taons.B2;
                   C2:=Taons.C2;
                   D2:=Taons.D2;
                   F2:=Taons.F2;
                   G2:=Taons.G2;
                   A3:=Taons.A3;
                   B3:=Taons.B3;
                   C3:=Taons.C3;
                   D3:=Taons.D3;
                   F3:=Taons.F3;
                   G3:=Taons.G3;
                   for n:=1 to MaxTaons do
                       Dao[n]:=Taons.Dao[n];
                   for n:=1 to MaxTaons do
                       begin
                       Xo[n]:=Taons.Xo[n];
                       Yo[n]:=Taons.Yo[n];
                       Zo[n]:=Taons.Zo[n];
                       Vo[n]:=Taons.Vo[n];
                       Uo[n]:=Taons.Uo[n];
                       Wo[n]:=Taons.Wo[n];

                       x[n]:=Xo[n];Xn[n]:=Xo[n];
                       y[n]:=Yo[n];Yn[n]:=Yo[n];
                       z[n]:=Zo[n];Zn[n]:=Zo[n];
                       Vn[n]:=Vo[n];
                       Un[n]:=Uo[n];
                       Wn[n]:=Wo[n];
                       end;
                   DrawLine;
                   ShowTable;
                   end
                   else
                       begin
                       CreateFigure;
                       end
                   end
            end
        else
            MessageDlg('The start File not found.', mtInformation, [mbOk], 0);
end;

procedure TMainForm.Left1Click(Sender: TObject);
begin
     xt:=xt-KoBok;
     if Spiral
        then ShowSpiral
        else DrawLine;
end;

procedure TMainForm.Right1Click(Sender: TObject);
begin
     xt:=xt+KoBok;
     if Spiral
        then ShowSpiral
        else DrawLine;
end;

procedure TMainForm.Up1Click(Sender: TObject);
begin
     zt:=zt-KoBok;
     if Spiral
        then ShowSpiral
        else DrawLine;
end;

procedure TMainForm.Down1Click(Sender: TObject);
begin
     zt:=zt+KoBok;
     if Spiral
        then ShowSpiral
        else DrawLine;
end;

procedure TMainForm.GoClick(Sender: TObject);
begin
if not Stop
   then
       begin
       Go.Kind:=bkOK;
       Go.Caption:='Go';
       ShapeRed.Brush.Color:=clMaroon;
       ShapeLime.Brush.Color:=clLime;
       Stop:=true;
       Images.Enabled:=true;
       Null00.Enabled:=true;
       end
   else
       begin
       Go.Kind:=bkCancel;
       Go.Caption:='Stop';
       ShapeRed.Brush.Color:=clRed;
       ShapeLime.Brush.Color:=clGreen;
       Stop:=false;
       Images.Enabled:=false;
       Null00.Enabled:=false;
       Null00.Caption:='0';
       Null00.Font.Color:=clMaroon;
       Game(Time);
       end;
end;

procedure TMainForm.DaonsTableDblClick(Sender: TObject);
begin
VeloCity:=not VeloCity; ShowTable;
end;

procedure TMainForm.New1Click(Sender: TObject);
begin
if EditDlg.ShowModal = mrOK then
   begin
   Spiral:=false;
   Go.Enabled:=true;
   Null00.Enabled:=true;
   FName.Text:=ThisName;
   Time:=0; LTime.Caption:='0';
   // Show result
   DrawLine;
   ShowTable;
   EditDT.Text:=FloatToStr(dt);
   EditA1.Text:=FloatToStr(A1);
   EditB1.Text:=FloatToStr(B1);
   EditC1.Text:=FloatToStr(C1);
   EditD1.Text:=FloatToStr(D1);
   EditF1.Text:=FloatToStr(F1);
   EditG1.Text:=FloatToStr(G1);
   EditA2.Text:=FloatToStr(A2);
   EditB2.Text:=FloatToStr(B2);
   EditC2.Text:=FloatToStr(C2);
   EditD2.Text:=FloatToStr(D2);
   EditF2.Text:=FloatToStr(F2);
   EditG2.Text:=FloatToStr(G2);
   EditA3.Text:=FloatToStr(A3);
   EditB3.Text:=FloatToStr(B3);
   EditC3.Text:=FloatToStr(C3);
   EditD3.Text:=FloatToStr(D3);
   EditF3.Text:=FloatToStr(F3);
   EditG3.Text:=FloatToStr(G3);
   //
   end;
end;

procedure TMainForm.Open1Click(Sender: TObject);
var n:integer;
begin
if OpenDialog.Execute then
   begin
   Spiral:=false;
   Go.Enabled:=true;
   Null00.Enabled:=true;
   ThisName:=OpenDialog.FileName;
   FName.Text:=ThisName;
   AssignFile(FTaons,OpenDialog.FileName);
   Reset(FTaons);
   Read(FTaons, Taons);
   CloseFile(FTaons);
   StartFile:=ThisName;
   Rewrite(FStartFile);
   Write(FStartFile, StartFile);
   CloseFile(FStartFile);
   // Write data of taons
   dt:=Taons.dt;
   A1:=Taons.A1;
   B1:=Taons.B1;
   C1:=Taons.C1;
   D1:=Taons.D1;
   F1:=Taons.F1;
   G1:=Taons.G1;
   A2:=Taons.A2;
   B2:=Taons.B2;
   C2:=Taons.C2;
   D2:=Taons.D2;
   F2:=Taons.F2;
   G2:=Taons.G2;
   A3:=Taons.A3;
   B3:=Taons.B3;
   C3:=Taons.C3;
   D3:=Taons.D3;
   F3:=Taons.F3;
   G3:=Taons.G3;

   for n:=1 to MaxTaons do
       Dao[n]:=Taons.Dao[n];
   for n:=1 to MaxTaons do
       begin
       Xo[n]:=Taons.Xo[n];
       Yo[n]:=Taons.Yo[n];
       Zo[n]:=Taons.Zo[n];
       Vo[n]:=Taons.Vo[n];
       Uo[n]:=Taons.Uo[n];
       Wo[n]:=Taons.Wo[n];

       x[n]:=Xo[n];Xn[n]:=Xo[n];
       y[n]:=Yo[n];Yn[n]:=Yo[n];
       z[n]:=Zo[n];Zn[n]:=Zo[n];
       Vn[n]:=Vo[n];
       Un[n]:=Uo[n];
       Wn[n]:=Wo[n];
       end;
   // Show result
   Time:=0; LTime.Caption:='0';
   DrawLine;
   ShowTable;
   EditDT.Text:=FloatToStr(dt);
   EditA1.Text:=FloatToStr(A1);
   EditB1.Text:=FloatToStr(B1);
   EditC1.Text:=FloatToStr(C1);
   EditD1.Text:=FloatToStr(D1);
   EditF1.Text:=FloatToStr(F1);
   EditG1.Text:=FloatToStr(G1);
   EditA2.Text:=FloatToStr(A2);
   EditB2.Text:=FloatToStr(B2);
   EditC2.Text:=FloatToStr(C2);
   EditD2.Text:=FloatToStr(D2);
   EditF2.Text:=FloatToStr(F2);
   EditG2.Text:=FloatToStr(G2);
   EditA3.Text:=FloatToStr(A3);
   EditB3.Text:=FloatToStr(B3);
   EditC3.Text:=FloatToStr(C3);
   EditD3.Text:=FloatToStr(D3);
   EditF3.Text:=FloatToStr(F3);
   EditG3.Text:=FloatToStr(G3);
   //
   // Commentary
   n:=Length(ThisName);
   Delete(ThisName,n-3,4);
   AssignFile(FTaonsText, ThisName+'.txt');
   {$I-}
   Reset(FTaonsText);
   {$I+}
   if IOResult=0 then
      begin
      CloseFile(FTaonsText);
      Comment.Lines.LoadFromFile(ThisName+'.txt');
      end;
   // End commentary
   end;
end;

procedure TMainForm.Save1Click(Sender: TObject);
begin
if not Spiral then
   begin
   SaveDataOfTaons;
   AssignFile(FTaons, ThisName);
   Rewrite(FTaons);
   Write(FTaons, Taons);
   CloseFile(FTaons);
   end;
end;

procedure TMainForm.Saveas1Click(Sender: TObject);
begin
if not Spiral then
if SaveDialog.Execute then
   begin
   ThisName:=SaveDialog.FileName;
   FName.Text:=ThisName;
   SaveDataOfTaons;
   AssignFile(FTaons,SaveDialog.FileName);
   Rewrite(FTaons);
   Write(FTaons, Taons);
   CloseFile(FTaons);
   StartFile:=ThisName;
   {$I-}
   Rewrite(FStartFile);
   {$I+}
   Write(FStartFile,StartFile);
   CloseFile(FStartFile);
   end;
end;

procedure TMainForm.MoveToCenterClick(Sender: TObject);
begin
xl:=120;
xt:=0;zt:=0;
if Spiral
   then ShowSpiral
   else DrawLine;
end;

procedure TMainForm.CommentChange(Sender: TObject);
begin
EditComm:=true;
end;

procedure TMainForm.CommentExit(Sender: TObject);
var n:integer;
begin
if EditComm then
   begin
   EditComm:=false;
   if MessageDlg('The text was changed. Save now?',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes then
      begin
      n:=Length(ThisName);
      Delete(ThisName,n-3,4);
      AssignFile(FTaonsText, ThisName+'.txt');
      Rewrite(FTaonsText);
      //Write(FTaonsText, '');
      CloseFile(FTaonsText);
      Comment.Lines.SaveToFile(ThisName+'.txt');
      //Comment.Lines.LoadFromFile(ThisName);
      end
   end
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
AboutBox.ShowModal;
end;

procedure TMainForm.Help1Click(Sender: TObject);
begin
{
  Application.HelpFile := 'Help.hlp';
  Application.HelpCommand(HELP_CONTENTS, 0);
}
end;
//*****************
procedure TMainForm.RusHelpClick(Sender: TObject);
  begin
     Application.HelpFile := 'HlpArtRu.hlp';
     Application.HelpCommand(HELP_CONTENTS, 0);
  end;
procedure TMainForm.PolHelpClick(Sender: TObject);
  begin
       Application.HelpFile := 'HlpArtPl.hlp';
       Application.HelpCommand(HELP_CONTENTS, 0);
  end;

procedure TMainForm.EditDTKeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditA1KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditB1KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditC1KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditD1KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditF1KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditG1KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditA2KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditB2KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditC2KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditD2KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditF2KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditG2KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditA3KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditB3KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditC3KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditD3KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditF3KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditG3KeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in ['0'..'9']) then
   if not (Key in ['-',',','.',#08]) then Key := #27
end;

procedure TMainForm.EditDTExit(Sender: TObject);
begin
dt:=StrToFloat(EditDT.Text);
end;

procedure TMainForm.EditA1Exit(Sender: TObject);
begin
A1:=StrToFloat(EditA1.Text);
end;

procedure TMainForm.EditB1Exit(Sender: TObject);
begin
B1:=StrToFloat(EditB1.Text);
end;

procedure TMainForm.EditC1Exit(Sender: TObject);
begin
C1:=StrToFloat(EditC1.Text);
end;

procedure TMainForm.EditD1Exit(Sender: TObject);
begin
D1:=StrToFloat(EditD1.Text);
end;

procedure TMainForm.EditF1Exit(Sender: TObject);
begin
F1:=StrToFloat(EditF1.Text);
end;

procedure TMainForm.EditG1Exit(Sender: TObject);
begin
G1:=StrToFloat(EditG1.Text);
end;

procedure TMainForm.EditA2Exit(Sender: TObject);
begin
A2:=StrToFloat(EditA2.Text);
end;

procedure TMainForm.EditB2Exit(Sender: TObject);
begin
B2:=StrToFloat(EditB2.Text);
end;

procedure TMainForm.EditC2Exit(Sender: TObject);
begin
C2:=StrToFloat(EditC2.Text);
end;

procedure TMainForm.EditD2Exit(Sender: TObject);
begin
D2:=StrToFloat(EditD2.Text);
end;

procedure TMainForm.EditF2Exit(Sender: TObject);
begin
F2:=StrToFloat(EditF2.Text);
end;

procedure TMainForm.EditG2Exit(Sender: TObject);
begin
G2:=StrToFloat(EditG2.Text);
end;

procedure TMainForm.EditA3Exit(Sender: TObject);
begin
A3:=StrToFloat(EditA3.Text);
end;

procedure TMainForm.EditB3Exit(Sender: TObject);
begin
B3:=StrToFloat(EditB3.Text);
end;

procedure TMainForm.EditC3Exit(Sender: TObject);
begin
C3:=StrToFloat(EditC3.Text);
end;

procedure TMainForm.EditD3Exit(Sender: TObject);
begin
D3:=StrToFloat(EditD3.Text);
end;

procedure TMainForm.EditF3Exit(Sender: TObject);
begin
F3:=StrToFloat(EditF3.Text);
end;

procedure TMainForm.EditG3Exit(Sender: TObject);
begin
G3:=StrToFloat(EditG3.Text);
end;

procedure TMainForm.Null00Click(Sender: TObject);
var i:integer;
begin
if not Spiral then
if Stop then
   begin
   for i:=1 to MaxTaons do
       begin
       Vo[i]:=0;Uo[i]:=0;Wo[i]:=0;
       Vn[i]:=0;Un[i]:=0;Wn[i]:=0;
       end;
   Null00.Caption:='Yes Null';
   Null00.Font.Color:=clMaroon;
   ShowTable;
   if SaveDialog.Execute then
      begin
      ThisName:=SaveDialog.FileName;
      FName.Text:=ThisName;
      SaveDataOfTaons;
      AssignFile(FTaons,SaveDialog.FileName);
      Rewrite(FTaons);
      Write(FTaons, Taons);
      CloseFile(FTaons);
      StartFile:=ThisName;
      {$I-}
      Rewrite(FStartFile);
      {$I+}
      Write(FStartFile,StartFile);
      CloseFile(FStartFile);
      end;
   end
end;

procedure TMainForm.LTimeDblClick(Sender: TObject);
begin
ShowLabelTime := not ShowLabelTime;
end;

end.
